//########## Security Cards

//### Items

datablock ItemData(gc_KeyCard1Item)
{
  uiName = "Security Card Blue";
  iconName = "./icon_card1";
  image = gc_KeyCard1Image;
  category = "Tools";
  className = "Weapon";
  shapeFile = "./card1.dts";
  mass = 1;
  density = 0.2;
  elasticity = 0;
  friction = 0.6;
  emap = true;
  armReady = true;
  doColorShift = true;
  colorShiftColor = "1 1 1 1";
  canDrop = true;
};

datablock ItemData(gc_KeyCard2Item : gc_KeyCard1Item)
{
  uiName = "Security Card Green";
  iconName = "./icon_card2";
  image = gc_KeyCard2Image;
  shapeFile = "./card2.dts";
};

datablock ItemData(gc_KeyCard3Item : gc_KeyCard1Item)
{
  uiName = "Security Card Yellow";
  iconName = "./icon_card3";
  image = gc_KeyCard3Image;
  shapeFile = "./card3.dts";
};

datablock ItemData(gc_KeyCard4Item : gc_KeyCard1Item)
{
  uiName = "Security Card Red";
  iconName = "./icon_card4";
  image = gc_KeyCard4Image;
  shapeFile = "./card4.dts";
};

//### Item Images

datablock ShapeBaseImageData(gc_KeyCard1Image)
{
  shapeFile = "./card1.dts";
  emap = true;
  correctMuzzleVector = true;
  className = "WeaponImage";
  item = gc_KeyCard1Item;
  melee = false;
  doReaction = false;
  armReady = false;
  doColorShift = true;
  colorShiftColor = "1 1 1 1";

  stateName[0] = "Activate";
  stateTimeoutValue[0] = 0.1;
  stateTransitionOnTimeout[0] = "Ready";
  stateSound[0] = weaponSwitchSound;

  stateName[1] = "Ready";
  stateTransitionOnTriggerDown[1] = "Fire";
  stateAllowImageChange[1] = true;

  stateName[2] = "Fire";
  stateTransitionOnTimeOut[2] = "Ready";
  stateTimeoutValue[2] = "0.2";
  stateFire[2] = true;
  stateAllowImageChange[2] = true;
  stateScript[2] = "onFire";
};

datablock ShapeBaseImageData(gc_KeyCard2Image)
{
  shapeFile = "./card2.dts";
  emap = true;
  correctMuzzleVector = true;
  className = "WeaponImage";
  item = gc_KeyCard2Item;
  melee = false;
  doReaction = false;
  armReady = false;
  doColorShift = true;
  colorShiftColor = "1 1 1 1";

  stateName[0] = "Activate";
  stateTimeoutValue[0] = 0.1;
  stateTransitionOnTimeout[0] = "Ready";
  stateSound[0] = weaponSwitchSound;

  stateName[1] = "Ready";
  stateTransitionOnTriggerDown[1] = "Fire";
  stateAllowImageChange[1] = true;

  stateName[2] = "Fire";
  stateTransitionOnTimeOut[2] = "Ready";
  stateTimeoutValue[2] = "0.2";
  stateFire[2] = true;
  stateAllowImageChange[2] = true;
  stateScript[2] = "onFire";
};

datablock ShapeBaseImageData(gc_KeyCard3Image)
{
  shapeFile = "./card3.dts";
  emap = true;
  correctMuzzleVector = true;
  className = "WeaponImage";
  item = gc_KeyCard3Item;
  melee = false;
  doReaction = false;
  armReady = false;
  doColorShift = true;
  colorShiftColor = "1 1 1 1";

  stateName[0] = "Activate";
  stateTimeoutValue[0] = 0.1;
  stateTransitionOnTimeout[0] = "Ready";
  stateSound[0] = weaponSwitchSound;

  stateName[1] = "Ready";
  stateTransitionOnTriggerDown[1] = "Fire";
  stateAllowImageChange[1] = true;

  stateName[2] = "Fire";
  stateTransitionOnTimeOut[2] = "Ready";
  stateTimeoutValue[2] = "0.2";
  stateFire[2] = true;
  stateAllowImageChange[2] = true;
  stateScript[2] = "onFire";
};

datablock ShapeBaseImageData(gc_KeyCard4Image)
{
  shapeFile = "./card4.dts";
  emap = true;
  correctMuzzleVector = true;
  className = "WeaponImage";
  item = gc_KeyCard4Item;
  melee = false;
  doReaction = false;
  armReady = false;
  doColorShift = true;
  colorShiftColor = "1 1 1 1";

  stateName[0] = "Activate";
  stateTimeoutValue[0] = 0.1;
  stateTransitionOnTimeout[0] = "Ready";
  stateSound[0] = weaponSwitchSound;

  stateName[1] = "Ready";
  stateTransitionOnTriggerDown[1] = "Fire";
  stateAllowImageChange[1] = true;

  stateName[2] = "Fire";
  stateTransitionOnTimeOut[2] = "Ready";
  stateTimeoutValue[2] = "0.2";
  stateFire[2] = true;
  stateAllowImageChange[2] = true;
  stateScript[2] = "onFire";
};

function gc_KeyCard1Image::onFire(%this,%obj,%slot)
{
  %raycast = containerRayCast(%obj.getEyePoint(),vectorAdd(%obj.getEyePoint(),vectorScale(%obj.getEyeVector(),3)),$TypeMasks::fxBrickObjectType);
  %thing = firstWord(%raycast);
  if(isObject(%thing)) %thing.onKeyCardHit(%obj.client);
}

function gc_KeyCard2Image::onFire(%this,%obj,%slot)
{
  %raycast = containerRayCast(%obj.getEyePoint(),vectorAdd(%obj.getEyePoint(),vectorScale(%obj.getEyeVector(),3)),$TypeMasks::fxBrickObjectType);
  %thing = firstWord(%raycast);
  if(isObject(%thing)) %thing.onKeyCardHit(%obj.client);
}

function gc_KeyCard3Image::onFire(%this,%obj,%slot)
{
  %raycast = containerRayCast(%obj.getEyePoint(),vectorAdd(%obj.getEyePoint(),vectorScale(%obj.getEyeVector(),3)),$TypeMasks::fxBrickObjectType);
  %thing = firstWord(%raycast);
  if(isObject(%thing)) %thing.onKeyCardHit(%obj.client);
}

function gc_KeyCard4Image::onFire(%this,%obj,%slot)
{
  %raycast = containerRayCast(%obj.getEyePoint(),vectorAdd(%obj.getEyePoint(),vectorScale(%obj.getEyeVector(),3)),$TypeMasks::fxBrickObjectType);
  %thing = firstWord(%raycast);
  if(isObject(%thing)) %thing.onKeyCardHit(%obj.client);
}

package gc_KeyCardEvents
{
  function fxDTSBrick::keyCardCheck(%obj,%accessType,%client)
  {
    if(%accessType == 0)
    {
        %obj.onKeyCardSuccess(%client);
    }
    if(%accessType == 1)
    {
        if(%client.player.getMountedImage(0).getname() $= "gc_KeyCard1Image")
          %obj.onKeyCardFailure(%client);
        else
          %obj.onKeyCardSuccess(%client);
    }
    if(%accessType == 2)
    {
        if(%client.player.getMountedImage(0).getname() $= "gc_KeyCard1Image" || %client.player.getMountedImage(0).getname() $= "gc_KeyCard2Image")
          %obj.onKeyCardFailure(%client);
        else
          %obj.onKeyCardSuccess(%client);
    }
    if(%accessType == 3)
    {
        if(%client.player.getMountedImage(0).getname() $= "gc_KeyCard1Image" || %client.player.getMountedImage(0).getname() $= "gc_KeyCard2Image" || %client.player.getMountedImage(0).getname() $= "gc_KeyCard3Image")
          %obj.onKeyCardFailure(%client);
        else
          %obj.onKeyCardSuccess(%client);
    }
  }
  function fxDTSBrick::onKeyCardSuccess(%this,%client)
  {
    $inputTarget_self = %this;
    $inputTarget_client = %client;
    $inputTarget_player = %client.player;
    $inputTarget_miniGame = getMiniGameFromObject(%this);
    %this.processInputEvent("onKeyCardSuccess",%client);
  }
  function fxDTSBrick::onKeyCardFailure(%this,%client)
  {
    $inputTarget_self = %this;
    $inputTarget_client = %client;
    $inputTarget_player = %client.player;
    $inputTarget_miniGame = getMiniGameFromObject(%this);
    %this.processInputEvent("onKeyCardFailure",%client);
  }
  function fxDTSBrick::onKeyCardHit(%this,%client)
  {
    $inputTarget_self = %this;
    $inputTarget_client = %client;
    $inputTarget_player = %client.player;
    $inputTarget_miniGame = getMiniGameFromObject(%this);
    %this.processInputEvent("onKeyCardHit",%client);
  }
};
ActivatePackage(gc_KeyCardEvents);

//### Events

registerInputEvent("fxDTSBrick","OnKeyCardSuccess","Self fxDTSBrick" TAB "Player Player" TAB "Client GameConnection" TAB "MiniGame MiniGame",1);
registerInputEvent("fxDTSBrick","OnKeyCardFailure","Self fxDTSBrick" TAB "Player Player" TAB "Client GameConnection" TAB "MiniGame MiniGame",1);
registerInputEvent("fxDTSBrick","OnKeyCardHit","Self fxDTSBrick" TAB "Player Player" TAB "Client GameConnection" TAB "MiniGame MiniGame",1);

registerOutputEvent("fxDTSBrick","keyCardCheck","list Level1 0 Level2 1 Level3 2 Level4 3",1);
